local lCollision = require("lCollision")

collider1 = lCollision:new(10, 10, 20, 20)
collider2 = lCollision:new(100, 100, 100, 100)
collider3 = lCollision:new(300, 100, 100, 100)
collider4 = lCollision:new(500, 100, 100, 100)

local colliders = {collider2, collider3, collider4}

speed = 3

local function booleanToNumber(boolean)
	return boolean and 1 or 0
end

function love.load()
	
end

function love.update(dt)
	local directionX = booleanToNumber(love.keyboard.isDown("right")) - booleanToNumber(love.keyboard.isDown("left"))
	local directionY = booleanToNumber(love.keyboard.isDown("down")) - booleanToNumber(love.keyboard.isDown("up"))
	
	collider1.x = collider1.x + directionX * speed
	collider1.y = collider1.y + directionY * speed
end

function love.draw()
	-- control description:
	love.graphics.setColor(1, 1, 1, 1)
	love.graphics.print("Arrow keys - Move", 0, 0)
	love.graphics.print("Space - separate", 0, 14)
	love.graphics.print("Mouse - Move", 0, 3*14)
	love.graphics.print("Mouse button - separate", 0, 4*14)
	
	-- draw agent:
	collider1:draw()
	
	-- collides()
	love.graphics.print("collides()", collider2.x, collider2.y - 20)
	if collider1:collides(collider2) then
		love.graphics.setColor(1, 0, 0, 1)
	end
	collider2:draw()
	
	-- insideOf()
	love.graphics.setColor(1, 1, 1, 1)
	love.graphics.print("insideOf()", collider3.x, collider3.y - 20)
	if collider1:insideOf(collider3) then
		love.graphics.setColor(1, 0, 0, 1)
	end
	collider3:draw()
	
	-- onBorder()
	love.graphics.setColor(1, 1, 1, 1)
	love.graphics.print("onBorder()", collider4.x, collider4.y - 20)
	if collider1:onBorder(collider4) then
		love.graphics.setColor(1, 0, 0, 1)
	end
	collider4:draw()
end


function love.keypressed (key, scancode)
	if key == "space" then
		for i, collider in ipairs (colliders) do
			collider1:separate(collider)
		end
	end
end

function love.mousemoved ( x, y, dx, dy)
	collider1.x = x - collider1.width
	collider1.y = y - collider1.height
end

function love.mousepressed ( x, y, iButton)
	if iButton == 1 then
		for i, collider in ipairs (colliders) do
			collider1:separate(collider)
		end
	end
end